--	Player frame.
function wPlayerFrame(self)
	PlayerStatusTexture:ClearAllPoints();
	PlayerStatusTexture:SetPoint("CENTER", PlayerFrame, "CENTER",16, 8);
	PlayerFrameTexture:SetTexture("Interface\\Addons\\"..whoaAddon.."\\\media\\UI-TargetingFrame");
	self.name:Hide();
	self.name:ClearAllPoints();
	self.name:SetPoint("CENTER", PlayerFrame, "CENTER",50.5, 36);
	self.healthbar:SetPoint("TOPLEFT",108,-24);
	self.healthbar:SetHeight(18);
	self.healthbar.LeftText:ClearAllPoints();
	self.healthbar.LeftText:SetPoint("LEFT",self.healthbar,"LEFT",5,0);	
	self.healthbar.RightText:ClearAllPoints();
	self.healthbar.RightText:SetPoint("RIGHT",self.healthbar,"RIGHT",-2,0);
	self.healthbar.TextString:SetPoint("CENTER", self.healthbar, "CENTER", 0, 0);
	self.manabar:SetPoint("TOPLEFT",108,-45);
	self.manabar:SetHeight(18);
	self.manabar.LeftText:ClearAllPoints();
	self.manabar.LeftText:SetPoint("LEFT",self.manabar,"LEFT",5,0)		;
	self.manabar.RightText:ClearAllPoints();
	self.manabar.RightText:SetPoint("RIGHT",self.manabar,"RIGHT",-2,0);
	self.manabar.TextString:SetPoint("CENTER",self.manabar,"CENTER",0,0);
	self.manabar.FullPowerFrame.SpikeFrame.AlertSpikeStay:ClearAllPoints();
	self.manabar.FullPowerFrame.SpikeFrame.AlertSpikeStay:SetPoint("CENTER", self.manabar.FullPowerFrame, "RIGHT", -6, -3);
	self.manabar.FullPowerFrame.SpikeFrame.AlertSpikeStay:SetSize(30,29);
	self.manabar.FullPowerFrame.PulseFrame:ClearAllPoints();
	self.manabar.FullPowerFrame.PulseFrame:SetPoint("CENTER", self.manabar.FullPowerFrame,"CENTER",-6,-2);
	self.manabar.FullPowerFrame.SpikeFrame.BigSpikeGlow:ClearAllPoints();
	self.manabar.FullPowerFrame.SpikeFrame.BigSpikeGlow:SetPoint("CENTER",self.manabar.FullPowerFrame,"RIGHT",5,-4);
	self.manabar.FullPowerFrame.SpikeFrame.BigSpikeGlow:SetSize(30,50);
	PlayerFrameGroupIndicatorText:ClearAllPoints();
	PlayerFrameGroupIndicatorText:SetPoint("CENTER", PlayerFrame,"TOP",-41,-6);
	PlayerFrameGroupIndicatorLeft:ClearAllPoints();
	PlayerFrameGroupIndicatorLeft:SetPoint("BOTTOMLEFT", PlayerFrame,"TOP",-65,-13);
	PlayerFrameGroupIndicatorRight:ClearAllPoints();
	PlayerFrameGroupIndicatorRight:SetPoint("BOTTOMLEFT", PlayerFrame,"TOP",-41,-13);
end
hooksecurefunc("PlayerFrame_ToPlayerArt", wPlayerFrame)

function WhoaGroupIndicator()
	local name, rank, subgroup;
	if ( not IsInRaid() ) then
		return;
	end
	local numGroupMembers = GetNumGroupMembers();
	for i=1, MAX_RAID_MEMBERS do
		if ( i <= numGroupMembers ) then
			name, rank, subgroup = GetRaidRosterInfo(i);
			if ( name == UnitName("player") ) then
				PlayerFrameGroupIndicatorText:SetText("G"..subgroup);
				PlayerFrameGroupIndicator:SetWidth(PlayerFrameGroupIndicatorText:GetWidth());-- +40);
				PlayerFrameGroupIndicator:Show();
			end
		end
	end
end
hooksecurefunc("PlayerFrame_UpdateGroupIndicator", WhoaGroupIndicator)

-- pet frame.
function whoaPetFrame(self, override)
	self.healthbar.LeftText:ClearAllPoints();
	self.healthbar.LeftText:SetPoint("LEFT",self.healthbar,"BOTTOM",35,5);
	self.healthbar.RightText:ClearAllPoints();
	self.healthbar.RightText:SetPoint("CENTER",self.healthbar,"BOTTOM",0,5);
	self.manabar.LeftText:SetAlpha(0);
	self.manabar.LeftText:ClearAllPoints();
	self.manabar.LeftText:SetPoint("LEFT",self.manabar,"TOP",0,-7);
	self.manabar.RightText:ClearAllPoints();
	self.manabar.RightText:SetPoint("CENTER",self.manabar,"TOP",0,-7);
end
hooksecurefunc("PetFrame_Update", whoaPetFrame)

--	Player vehicle frame.
function whoaVehicleFrame(self, vehicleType)
		if ( vehicleType == "Natural" ) then
		PlayerFrameVehicleTexture:SetTexture("Interface\\Vehicles\\UI-Vehicle-Frame-Organic");
		PlayerFrameFlash:SetTexture("Interface\\Vehicles\\UI-Vehicle-Frame-Organic-Flash");
		PlayerFrameFlash:SetTexCoord(-0.02, 1, 0.07, 0.86);
		self.healthbar:SetSize(103,12);
		self.healthbar:SetPoint("TOPLEFT",116,-41);
		self.manabar:SetSize(103,12);
		self.manabar:SetPoint("TOPLEFT",116,-52);
	else
		PlayerFrameVehicleTexture:SetTexture("Interface\\Vehicles\\UI-Vehicle-Frame");
		PlayerFrameFlash:SetTexture("Interface\\Vehicles\\UI-Vehicle-Frame-Flash");
		PlayerFrameFlash:SetTexCoord(-0.02, 1, 0.07, 0.86);
		self.healthbar:SetSize(100,12);
		self.healthbar:SetPoint("TOPLEFT",119,-41);
		self.manabar:SetSize(100,12);
		self.manabar:SetPoint("TOPLEFT",119,-52);
	end
	PlayerName:SetPoint("CENTER",50,23);
	PlayerFrameBackground:SetWidth(114);
end
hooksecurefunc("PlayerFrame_ToVehicleArt", whoaVehicleFrame)

	-- vehicle switch
local whoaStatusFrame = CreateFrame("Frame")
whoaStatusFrame:SetScript('OnEvent', function(self, event, ...)
	if ( event == "UNIT_ENTERED_VEHICLE" ) then
				cfg.doVehicleFrame = true;
	elseif ( event == "UNIT_EXITED_VEHICLE" ) then
		cfg.doVehicleFrame = false;
	end
	return cfg.doVehicleFrame;
end)

	-- Vehicle color.
whoaStatusFrame:RegisterUnitEvent("PLAYER_ENTERING_WORLD");
whoaStatusFrame:RegisterUnitEvent("UNIT_ENTERED_VEHICLE");
whoaStatusFrame:RegisterUnitEvent("UNIT_EXITED_VEHICLE");
whoaStatusFrame:SetScript('OnUpdate', function(self)
	if (TargetFrameNumericalThreat:IsVisible() or FocusFrameNumericalThreat:IsVisible()) or cfg.playerNameHide then
		PlayerName:Hide();
	elseif not (TargetFrameNumericalThreat:IsVisible() or FocusFrameNumericalThreat:IsVisible()) and not cfg.playerNameHide then
		PlayerName:Show();
	end
	if ( cfg.doVehicleFrame ) then
		PlayerFrameHealthBar:SetStatusBarColor(whoaUnitColor("pet"));
		PetFrameHealthBar:SetStatusBarColor(whoaUnitColor("player"));
	else
		PlayerFrameHealthBar:SetStatusBarColor(whoaUnitColor("player"));
		if UnitExists("pet") then
			PetFrameHealthBar:SetStatusBarColor(whoaUnitColor("pet"));
		end
	end
	TargetFrameHealthBar:SetStatusBarColor(whoaUnitColor("target"));
	FocusFrameHealthBar:SetStatusBarColor(whoaUnitColor("focus"));
	TargetFrameToTHealthBar:SetStatusBarColor(whoaUnitColor("targettarget"));
	FocusFrameToTHealthBar:SetStatusBarColor(whoaUnitColor("focustarget"));
	--	party statusbar
	for i = 1, 4 do
		if i then
			_G["PartyMemberFrame"..i.."HealthBar"]:SetStatusBarColor(whoaUnitColor("party"..i));
		end
	end
	--	boss statusbar
	for i = 1, MAX_BOSS_FRAMES do
		if i then
			_G["Boss"..i.."TargetFrameHealthBar"]:SetStatusBarColor(whoaUnitColor("boss"..i));
		end
	end
end)